<template>
  <div class="padding">
    <div class="range-slider">
      <div class="row">
        <div class="columns six">
          <div class="upper-header">Сумма займа:</div>
          <div class="row range-slider__upper-text upper-text">
            <div class="columns seven big">
              <div class="manual-entry">
                {{sum|currency}}
              </div>
              <div class="name-field-amount" :class="{'name-field-amount-min': sum > 9500 ? false : true}">₽</div>
            </div>
            <div class="columns five small">К возврату: <strong>{{ returnSum }} ₽</strong></div>
          </div>

          <!-- Slider Amount -->

          <div class="range-slider">
            <div ref="track" tabindex="0" class="slider" @mousedown="trackClick" @keydown.left.right="movement">
              <div class="color" ref="pathway" :style="widthStyleAmount"></div>
              <div class="bumper"
                   :style="leftStyleSum"
                   ref="circle"
                   @mousedown.prevent="decline"
                   @touchstart="decline"
              ></div>
            </div>
            <div class="column liner"></div>
            <div class="row range">
              <div class="columns six">
                {{$calculate.sum_min}}
              </div>
              <div class="columns six right">
                {{ $calculate.sum_max }}
              </div>
            </div>
          </div>

          <!---->

        </div>

        <div class="columns six">
          <div class="upper-header">Срок займа:</div>
          <div class="row range-slider__upper-text upper-text">
            <div class="columns seven big">
              <div class="manual-entry">
                {{days}}
              </div>
              <div class="name-field-days">
                {{ $helpers.plural(days, sum > 20000 ? ['месяц', 'месяца', 'месяцев'] : ['день', 'дня', 'дней']) }}
              </div>
            </div>
            <div class="columns five small">Дата возврата: <strong>{{ returnDate }}</strong></div>
          </div>

          <!--Slider Date-->

          <div class="range-slider">
            <div ref="trackDate" tabindex="0" class="slider" @mousedown="dateClick" @keydown.left.right="traffic">
              <div class="color" ref="pathway" :style="widthStyleDate"></div>
              <div class="bumper"
                   :style="leftStyleDate"
                   ref="circle"
                   @mousedown.prevent="falling"
                   @touchstart="falling"
              ></div>
            </div>
            <div class="column liner"></div>
            <div class="row range">
              <div class="columns six" v-if="sum <= 20000">
                {{periodMin}}
              </div>
              <div class="columns six right" v-if="sum <= 20000">
                {{periodMax}}
              </div>
              <div v-if="sum > 20000">
                <span>3</span>
                <span class="block-month-slider" style="width: 34%">4</span>
                <span class="block-month-slider" style="width: 29%">5</span>
                <span class="block-month-slider" style="float: right">6</span>
              </div>
            </div>
          </div>

          <!---->

        </div>
      </div>
    </div>
  </div>
</template>

<script>
  import {getDateAfterDays, getMonth, num2words} from '@/utils/helpers'

  const roundPercent = (coeff) => {
    if (coeff >= 0 && coeff <= 1) {
      return Math.round(coeff * 1000) / 10
    } else
    if (coeff > 1) { return 100 }
    return 0
  };

  const rangeDate = (coeff) => {
    if (coeff >= 0 && coeff <= 1) {
      return Math.round(coeff * 1000) / 10
    } else
    if (coeff > 1) { return 100 }
    return 0
  };

  let canContinue = true;
  let haveTime = true;

  export default {
    name: 'CreditRate',
      props: {
        servicePrice: {
            required: false,
            type: Number,
            default: 0
        }
      },
    data () {
      return {
        fix_percent: 0.6,
        flag: false,
        fullOffSum: 0,
        fullOfDate: 0,
        percentSum: 0,
        percentDays: 0,
        stepSumPercent: null,
        stepDaysPercent: null,
        discretePercentAmount: null,
        discretePercentage: null
      }
    },
    computed: {
      leftStyleSum () {
        if ((this.sum > 15000) && (this.$qiwi === true)) {
          this.percentSum = (14500 / this.$calculate.sum_max) * 100
        }

        if ((this.sum > 20000) && (this.sum < 25000)) {
          this.sum = 20000
        }

        if ((this.sum > 25000) && (this.sum < 30000)) {
          this.sum = 30000
        }
        return `left: ${this.percentSum}%;`
      },
      widthStyleAmount () {
        return `width: ${this.percentSum}%;`
      },
      leftStyleDate () {
        return `left: ${this.percentDays}%;`
      },
      widthStyleDate () {
        return `width: ${this.percentDays}%;`
      },
      sum () {
        if (500 * Math.round((this.$calculate.sum_max - this.$calculate.sum_min) * this.percentSum / 100 / 500) + this.$calculate.sum_min <= 20000) {
          this.$store.commit('CHANGE_LOAN_TYPE', 1);
          return 500 * Math.round((this.$calculate.sum_max - this.$calculate.sum_min) * this.percentSum / 100 / 500) + this.$calculate.sum_min
        }
        if ((500 * Math.round((this.$calculate.sum_max - this.$calculate.sum_min) * this.percentSum / 100 / 500) + this.$calculate.sum_min > 20000) && (500 * Math.round((this.$calculate.sum_max - this.$calculate.sum_min) * this.percentSum / 100 / 500) + this.$calculate.sum_min < 30000)) {
          this.$store.commit('CHANGE_LOAN_TYPE', 8);
          return 30000;
        }
        if (500 * Math.round((this.$calculate.sum_max - this.$calculate.sum_min) * this.percentSum / 100 / 500) + this.$calculate.sum_min >= 30000) {
          this.$store.commit('CHANGE_LOAN_TYPE', 8);
          return 1000 * Math.round((this.$calculate.sum_max - this.$calculate.sum_min) * this.percentSum / 100 / 1000) + this.$calculate.sum_min
        }
      },
      days () {
        return Math.round((this.periodMax - this.periodMin) * this.percentDays / 100 ) + this.periodMin
      },
      returnSum () {
        if (this.sum <= 20000) {
          let percent_sum = 0;
          for(let i = 0;i < this.days; i++) {
            percent_sum += this.sum / 100 * this.$calculate.period_percents[this.days - 1];
          }
          return (this.sum + percent_sum + this.servicePrice).toFixed(2);
        }
        if (this.sum >= 30000) {
          // return this.sum + ((this.sum * this.checkerDate() * this.fix_percent) / 100)
          let sum = 0;
          this.$graphicInstallment.forEach((key) => sum += key.amount);
          return sum.toFixed(2);
        }
      },
      periodMin () {
        return this.sum > 20000 ? 3 : this.$calculate.period_min
      },
      periodMax () {
        return this.sum > 20000 ? 6 : this.$calculate.period_max
      },
      returnDate () {
        if (this.sum > 20000) {
          let month = getMonth(this.$dayjs().add(this.days, 'months').format('M'));
          return this.$dayjs().add(this.days, 'months').format(`DD ${month} YYYY`)
        }
        return getDateAfterDays(this.days)
      },
    },
    methods: {
      getFullOffSum (element, sum) {
        if (element.offsetParent) {
          return this.getFullOffSum(element.offsetParent, sum + element.offsetLeft)
        }
        return sum
      },
      getFullOfDate (element, days) {
        if (element.offsetParent) {
          return this.getFullOfDate(element.offsetParent, days + element.offsetLeft)
        }
        return days
      },
      calcFullOffSum () {
        this.fullOffSum = this.getFullOffSum(this.$refs.track, 0)
      },
      calcFullOfDate () {
        this.fullOfDate = this.getFullOfDate(this.$refs.trackDate, 0)
      },
      showSum (e) {
        if (canContinue) {
          this.discretePercentAmount = Math.round(this.stepSumPercent * Math.round(this.percentSum / this.stepSumPercent));
          const clientX = e.clientX || e.touches[0].clientX;
          this.percentSum = roundPercent((clientX - this.fullOffSum) / this.$refs.track.offsetWidth);
          canContinue = false;
          setTimeout(() => canContinue = true, 25)
        }
      },
      showDate (e) {
        if (haveTime) {
          this.discretePercentage = Math.round(this.stepDaysPercent * Math.round(this.percentDays / this.stepDaysPercent));
          const clientX = e.clientX || e.touches[0].clientX;
          this.percentDays = rangeDate((clientX - this.fullOfDate) / this.$refs.track.offsetWidth);
          haveTime = false;
          setTimeout(() => haveTime = true, 25)
        }
      },
      trackClick (e) {
        const clientX = e.clientX || e.touches[0].clientX;
        this.percentSum = roundPercent((clientX - this.fullOffSum) / this.$refs.track.offsetWidth);
        if ((this.sum > 15000) && (this.$qiwi === true)) {
          this.$toastr.warning('Максимальная сумма займа выданного на QIWI кошелек не может быть более 15.000р. Сумма автоматически уменьшена до максимально возможной.')
        }
        if ((this.flag === false) && (this.sum >= 30000)) {
          this.percentDays = 0;
          this.flag = true
        }
        if (this.sum <= 20000) {
          this.flag = false
        }
      },
      dateClick (e) {
        const clientX = e.clientX || e.touches[0].clientX;
        this.percentDays = rangeDate((clientX - this.fullOfDate) / this.$refs.trackDate.offsetWidth);
        if (this.sum >= 30000) {
          if (this.percentDays >= 0 && this.percentDays <= 25) this.percentDays = 0;
          if (this.percentDays >= 26 && this.percentDays <= 50) this.percentDays = 34;
          if (this.percentDays >= 51 && this.percentDays <= 75) this.percentDays = 64;
          if (this.percentDays >= 76 && this.percentDays <= 100) this.percentDays = 100;
        }
      },
      movement (event) {
        if (event.key === 'ArrowRight') this.percentSum = roundPercent((Number(this.percentSum) + Number(this.stepSumPercent)) / 100);
        if (event.key === 'ArrowLeft') this.percentSum = roundPercent((Number(this.percentSum) - Number(this.stepSumPercent)) / 100)
      },
      traffic (event) {
        if (event.key === 'ArrowRight') this.percentDays = rangeDate((Number(this.percentDays) + Number(this.stepSumPercent)) / 100);
        if (event.key === 'ArrowLeft') this.percentDays = rangeDate((Number(this.percentDays) - Number(this.stepSumPercent)) / 100)
      },
      mouseUp () {
        this.$emit('mouseup');
        document.removeEventListener('mousemove', this.showSum);
        document.removeEventListener('touchmove', this.showSum);
        document.removeEventListener('mouseup', this.mouseUp);
        document.removeEventListener('touchend', this.mouseUp);
        this.percentSum = this.discretePercentAmount;
        if ((this.$qiwi === true) && (this.$calculate.sum_max > 15000) && (this.sum === 15000)) {
          this.$toastr.warning('Максимальная сумма займа выданного на QIWI кошелек не может быть более 15.000р. Сумма автоматически уменьшена до максимально возможной.')
        }
        if ((this.flag === false) && (this.sum >= 30000)) {
          this.percentDays = 0;
          this.flag = true
        }
        if (this.percentSum > 39 && this.percentSum < 50) {
          this.percentSum = 39
        }
        if (this.percentSum >= 50 && this.percentSum < 60) {
          this.percentSum = 60
        }
        if (this.sum <= 20000) {
          this.flag = false
        }
      },
      mouseUpDate () {
        this.$emit('mouseup');
        document.removeEventListener('mousemove', this.showDate);
        document.removeEventListener('touchmove', this.showDate);
        document.removeEventListener('mouseup', this.mouseUpDate);
        document.removeEventListener('touchend', this.mouseUpDate);
        this.percentDays = this.discretePercentage;
        if (this.sum >= 30000) {
          if (this.percentDays >= 0 && this.percentDays <= 25) {
            this.percentDays = 0;
          }
          if (this.percentDays >= 26 && this.percentDays <= 50) {
            this.percentDays = 34;
          }
          if (this.percentDays >= 51 && this.percentDays <= 75) {
            this.percentDays = 64;
          }
          if (this.percentDays >= 76 && this.percentDays <= 100) {
            this.percentDays = 100;
          }
        }
      },
      decline (event) { // функция на передвижение бегунка у Суммы займа
        event.stopPropagation();
        this.calcFullOffSum();
        this.$refs.track.focus();
        event.preventDefault();
        document.addEventListener('mousemove', this.showSum);
        document.addEventListener('touchmove', this.showSum);
        document.addEventListener('mouseup', this.mouseUp);
        document.addEventListener('touchend', this.mouseUp)
      },
      falling (event) { // функция на передвижение бегунка у Сроков займа
        event.stopPropagation();
        this.calcFullOfDate();
        this.$refs.trackDate.focus();
        event.preventDefault();
        document.addEventListener('mousemove', this.showDate);
        document.addEventListener('touchmove', this.showDate);
        document.addEventListener('mouseup', this.mouseUpDate);
        document.addEventListener('touchend', this.mouseUpDate)
      },
      checkerDate () {
        let dateFrom = this.$dayjs(this.$dayjs(new Date()).format('YYYY-MM-DD'));
        let dateTo = this.$dayjs(this.$dayjs().add(this.days, 'months').format('YYYY-MM-DD'));
        let days = dateTo.diff(dateFrom, 'day');
        return this.sum >= 30000 ? days : this.days
      }
    },
    watch: {
      sum () {
        this.$emit('change', {sum: this.sum, days: this.checkerDate(), countMonth: this.days})
      },
      days () {
        this.$emit('change', {sum: this.sum, days: this.checkerDate(), countMonth: this.days})
      }
    },
    mounted () {
      this.calcFullOffSum();
      this.calcFullOfDate();
    },
    created () {
        // console.info('CreditRate::servicePrice', this.servicePrice);
      this.percentSum = 48;
      this.percentDays = 0;
      this.stepSumPercent = parseFloat((100 / (this.$calculate.sum_max / 500)).toFixed(2));
      this.stepDaysPercent = parseFloat((100 / (this.$calculate.period_max)).toFixed(2));
      this.discretePercentAmount = Math.round(this.stepSumPercent * Math.round(this.percentSum / this.stepSumPercent));
      this.discretePercentage = Math.round(this.stepDaysPercent * Math.round(this.percentDays / this.stepDaysPercent));
      if (this.$cookie.get('loanSum') !== null) {
        if (this.$cookie.get('loanSum') !== 0) {
          let sum = 0;
          if (this.$cookie.get('loanSum') >= 1000 && this.$cookie.get('loanSum') <= 4500) {
            sum = parseInt(this.$cookie.get('loanSum')) - 1000;
            this.percentSum = (sum / this.$calculate.sum_max) * 100;
          }
          if (this.$cookie.get('loanSum') >= 5000 && this.$cookie.get('loanSum') <= 1100) {
            sum = parseInt(this.$cookie.get('loanSum')) - 500;
            this.percentSum = (sum / this.$calculate.sum_max) * 100;
          }
          if ((this.$cookie.get('loanSum') >= 11500) && (this.$cookie.get('loanSum') >= 20000)) {
            sum = parseInt(this.$cookie.get('loanSum'));
            this.percentSum = (sum / this.$calculate.sum_max) * 100;
          }
        }
      }

      if (this.$cookie.get('loanDays') !== null) {
        if (this.$cookie.get('loanDays') !== 0) {
          let date = 0;
          if ((this.$cookie.get('loanDays') >= 5) && (this.$cookie.get('loanDays') <= 8)) {
            date = parseInt(this.$cookie.get('loanDays')) - 5;
            this.percentDays = (date / this.$calculate.sum_max) * 100;
          }
          if ((this.$cookie.get('loanDays') >= 9) && (this.$cookie.get('loanDays') <= 13)) {
            date = parseInt(this.$cookie.get('loanDays')) - 4;
            this.percentDays = (date / this.$calculate.sum_max) * 100;
          }
          if ((this.$cookie.get('loanDays') >= 14) && (this.$cookie.get('loanDays') <= 18)) {
            date = parseInt(this.$cookie.get('loanDays')) - 3;
            this.percentDays = (date / this.$calculate.sum_max) * 100;
          }
          if ((this.$cookie.get('loanDays') >= 19) && (this.$cookie.get('loanDays') <= 23)) {
            date = parseInt(this.$cookie.get('loanDays')) - 2;
            this.percentDays = (date / this.$calculate.sum_max) * 100;
          }
          if ((this.$cookie.get('loanDays') >= 24) && (this.$cookie.get('loanDays') <= 27)) {
            date = parseInt(this.$cookie.get('loanDays')) - 1;
            this.percentDays = (date / this.$calculate.sum_max) * 100;
          }
          if ((this.$cookie.get('loanDays') === 29) || (this.$cookie.get('loanDays') === 30)) {
            date = parseInt(this.$cookie.get('loanDays'));
            this.percentDays = (date / this.$calculate.sum_max) * 100;
          }
        }
      }
    },
  }
</script>

<style scoped lang="scss">
  .range {
    & div {
      box-sizing: border-box;
      & span.block-month-slider {
        box-sizing: border-box;
        text-align: right;
        display: inline-block;
        &:first-child {
        }
      }
    }
  }
  .text-red {
    color: #ff3e3e !important;
  }
  .name-field-amount-min {
    left: 90px;
  }
  .name-field-days {
    left: 4px !important;
  }
</style>
